<template>
  <v-layout :fill-height="$vuetify.breakpoint.mdAndDown" class="writing-instructions mt-1" wrap>
    <v-flex lg12 v-if="$vuetify.breakpoint.lgAndUp">
      <writing-title :title="description.text"/>
    </v-flex>
    <v-layout justify-center class="writing-instructions__card">
      <v-flex xs12 lg10 d-flex justify-center class="pa-1">
        <component
          class="writing-instructions__component"
          :content="introductionContent"
          :is="introductionType"
        ></component>
      </v-flex>
      <v-flex lg2 v-if="$vuetify.breakpoint.lgAndUp">
        <sidebar-navigation
          :all-types="allItemsType"
          :active="activeBottomItem"
          @selected="selectedItem"
        />
      </v-flex>
    </v-layout>
    <bottom-navigation
      v-if="$vuetify.breakpoint.mdAndDown"
      :all-types="allItemsType"
      :active="activeBottomItem"
      @selected="selectedItem"
    />
  </v-layout>
</template>

<script>
import WritingFooter from '../Footer/Index';
import WritingText from './components/Text/Index';
import WritingImage from './components/Image/Index';
import WritingAudio from './components/Audio/Index';
import WritingVideo from './components/Video/Index';
import BottomNavigation from '../Footer/Components/BottomNavigation';
import SidebarNavigation from '../Footer/Components/SidebarNavigation';
import WritingTitle from '../Title/Index';

export default {
  components: {
    BottomNavigation,
    SidebarNavigation,
    WritingFooter,
    WritingText,
    WritingImage,
    WritingAudio,
    WritingVideo,
    WritingTitle,
  },
  props: {
    questions: {
      type: Array,
    },
    description: {
      type: Object,
    },
  },
  data() {
    return {
      activeBottomItem: '',
    };
  },
  methods: {
    selectedItem(item) {
      this.activeBottomItem = item;
    },
  },
  computed: {
    allItemsType() {
      return this.questions.map(it => it.type).reverse();
    },
    introductionContent() {
      return this.questions.filter(it => it.type === this.activeBottomItem);
    },
    introductionType() {
      const components = {
        text: WritingText,
        image: WritingImage,
        audio: WritingAudio,
        video: WritingVideo,
      };
      return components[this.activeBottomItem];
    },
  },
  created() {
    [this.activeBottomItem] = this.allItemsType;
  },
};
</script>

<style lang="sass">
@import ~@/styles/defaults/variables
@import ~@/styles/defaults/mobileFirst


.writing-instructions
  width: 100%
  overflow: auto
  position: relative
  &__component
    border: 1px solid rgba(0,0,0,.2)
  +media-min-lg()
    height: auto
    min-height: 40vh
    padding: 5px 0px 5px
    &__component
      border-radius: 3px
      min-height: 30vh
      height: 100%
      border: 1px solid rgba(0,0,0,.2)


</style>
